# All files / src/node-transformers/node-obfuscators MethodDefinitionObfuscator.ts

100% Statements 20/20
100% Branches 5/5
100% Functions 2/2
100% Lines 17/17

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    771x
    1x

    1x

    1x

    1x
    1x

    1x

    1x

    3x

    3x

    6x

    6x

    6x

    3x
    3x

    3x

    3x

     import { injectable, inject } from 'inversify';
    import { ServiceIdentifiers } from '../../container/ServiceIdentifiers';

    import * as estraverse from 'estraverse';
    import * as ESTree from 'estree';

    import { IOptions } from '../../interfaces/options/IOptions';
    import { IObfuscatorReplacer } from '../../interfaces/node-transformers/IObfuscatorReplacer';

    import { NodeObfuscatorsReplacers } from '../../enums/container/NodeObfuscatorsReplacers';

    import { AbstractNodeTransformer } from '../AbstractNodeTransformer';
    import { Node } from '../../node/Node';

    /**
     * replaces:
     *     foo () { //... };
     *
     * on:
     *     [_0x9a4e('0x0')] { //... };
     */
    @injectable()
    export class MethodDefinitionObfuscator extends AbstractNodeTransformer {
        /**
         * @type {IObfuscatorReplacer}
         */
        private readonly stringLiteralReplacer: IObfuscatorReplacer;

        /**
         * @type {string[]}
         */
        private static readonly ignoredNames: string[] = ['constructor'];

        /**
         * @param replacersFactory
         * @param options
         */
        constructor(
            @inject(ServiceIdentifiers['Factory<IObfuscatorReplacer>']) replacersFactory: (replacer: NodeObfuscatorsReplacers) => IObfuscatorReplacer,
            @inject(ServiceIdentifiers.IOptions) options: IOptions
        ) {
            super(options);

            this.stringLiteralReplacer = replacersFactory(NodeObfuscatorsReplacers.StringLiteralReplacer);
        }

        /**
         * @param methodDefinitionNode
         * @param parentNode
         */
        public transformNode (methodDefinitionNode: ESTree.MethodDefinition, parentNode: ESTree.Node): void {
            this.replaceMethodName(methodDefinitionNode);
        }

        /**
         * @param methodDefinitionNode
         */
        private replaceMethodName (methodDefinitionNode: ESTree.MethodDefinition): void {
            estraverse.replace(methodDefinitionNode.key, {
                enter: (node: ESTree.Node): any => {
                    if (
                        Node.isIdentifierNode(node) &&
                        !MethodDefinitionObfuscator.ignoredNames.includes(node.name) &&
                        methodDefinitionNode.computed === false
                    ) {
                        methodDefinitionNode.computed = true;
                        node.name = this.stringLiteralReplacer.replace(node.name);

                        return;
                    }

                    return estraverse.VisitorOption.Skip;
                }
            });
        }
    }